var Menu = require('terminal-menu');
var menu = Menu({ width: 40, x: 4, y: 2 });

var m = {
	init: function () {
		process.stdin.pipe(menu.createStream()).pipe(process.stdout);

		process.stdin.setRawMode(true);
		menu.on('close', function () {
		    process.stdin.setRawMode(false);
		    process.stdin.end();
		});
	},
	showTitle : function (title) {
		menu.reset();
		menu.write(title + '\n');
		menu.write('----------------------------------------\n');
	},
	runCode : function (filename) {
		if (!filename) return;

		// Todo: Need to find out a way to specify current running folder.
		var m = require('../../'+filename);
		m.initialize && m.initialize();
		m.run && m.run();
		m.finalize && m.finalize();
	},
	addmenu : function (label, filename) {
		menu.add(label, function () {
			m.runCode(filename);
			if (label == 'EXIT' || label == 'CLOSE') menu.close();
		});
	}
}

module.exports = m;